If the application wants to close a session it hasn't opened, we shouldn't fail
outright, but return the result of running the stack.

--- Linux-PAM-0.75/libpam/pam_dispatch.c
+++ Linux-PAM-0.75/libpam/pam_dispatch.c
@@ -99,10 +99,14 @@
 	    return retval;
 	}
 
+	cached_retval = -1;
+
 	if (use_cached_chain) {
 	    /* a former stack execution has frozen the chain */
 	    cached_retval = *(h->cached_retval_p);
-	} else {
+	}
+
+	if (cached_retval == -1) {
 	    /* this stack execution is defining the frozen chain */
 	    cached_retval = h->cached_retval = retval;
 	}
